#version 450
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define UTEXTURE_2D utexture2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define UTEXTURE_2D utexture2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////

struct _340
{
    vec3 _m0;
    vec3 _m1;
    vec3 _m2;
    float _m3;
    float _m4;
    float _m5;
    vec3 _m6;
    vec3 _m7;
    vec3 _m8;
    vec3 _m9;
    vec3 _m10;
    float _m11;
    float _m12;
    vec3 _m13;
    vec3 _m14;
    vec4 _m15;
    vec4 _m16;
    mat3 _m17;
    vec3 _m18;
    vec3 _m19;
    vec3 _m20;
    vec3 _m21;
    uint _m22;
    uint _m23;
    uint _m24;
    uint _m25;
    vec3 _m26;
    vec3 _m27;
    uvec4 _m28;
    uvec4 _m29;
    uvec4 _m30;
    vec3 _m31;
    vec3 _m32;
    ivec3 _m33;
    vec4 _m34;
    vec4 _m35;
    vec4 _m36;
    float _m37;
    uint _m38;
};

struct _607
{
    int _m0;
    int _m1;
};

struct _610
{
    int _m0;
    int _m1;
};


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 10, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(set = 0, binding = 0, std140) uniform _362_364
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
} _364;

layout(set = 2, binding = 0, std140) uniform _448_450
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
} _450;

layout(set = 1, binding = 0, std140) uniform _497_499
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
} _499;

layout(set = 0, binding = 4, std430) restrict readonly buffer _612_614
{
    _610 _m0[];
} _614;

layout(set = 0, binding = 1, std430) restrict readonly buffer _1023_1025
{
    vec4 _m0[];
} _1025;

layout(push_constant, std430) uniform _1019_1021
{
    int _m0;
    int _m1;
} _1021;

layout(set = 2, binding = 1) uniform SAMPLER_2D _445;
layout(set = 2, binding = 2) uniform SAMPLER_2D _473;
layout(set = 2, binding = 3) uniform SAMPLER_2D _796;
layout(set = 2, binding = 4) uniform SAMPLER_2D _997;
layout(set = 0, binding = 2) uniform sampler3D _1029;
layout(set = 0, binding = 3) uniform sampler3D _1030;

layout(location = 2) in vec4 _354;
layout(location = 6) in vec4 _370;
layout(location = 3) in vec4 _382;
layout(location = 4) in vec4 _385;
layout(location = 5) in vec4 _388;
layout(location = 10) in vec4 _406;
layout(location = 11) in vec4 _410;
layout(location = 12) in vec4 _414;
layout(location = 7) in vec4 _798;
layout(location = 0) out vec4 _920;
layout(location = 1) out vec4 _931;
layout(location = 2) out vec4 _939;
layout(location = 3) out vec4 _970;

float _122;

float _24(float _23)
{
    if (_23 <= 0.040449999272823333740234375)
    {
        return _23 / 12.9200000762939453125;
    }
    else
    {
        return pow((_23 / 1.05499994754791259765625) + 0.0521326996386051177978515625, 2.400000095367431640625);
    }
}

vec3 _30(vec3 _29)
{
    float _124 = _29.x;
    vec3 _123;
    _123.x = _24(_124);
    float _131 = _29.y;
    _123.y = _24(_131);
    float _137 = _29.z;
    _123.z = _24(_137);
    return _123;
}

vec4 _34(vec4 _33)
{
    vec3 _147 = _33.xyz;
    vec4 _146 = vec4(_30(_147), 1.0);
    float _155 = _33.w;
    _146.w = _24(_155);
    return _146;
}

vec4 _37(vec4 _36)
{
    vec4 _164 = _36;
    return _34(_164);
}

vec4 _53(SAMPLER_2D _51, vec2 _52)
{
    vec4 _178 = SAMPLE_TEXTURE(_51, _52);
    vec4 _182 = _178;
    _178 = _37(_182);
    return _178;
}

float _14(float _13)
{
    return clamp(_13, 0.0, 1.0);
}

float _62(float _58, vec4 _59, float _60, bool _61)
{
    float _188 = _59.w / (_58 + _59.z);
    return _188 * _60;
}

vec3 _67(vec3 _65, bool _66)
{
    vec3 _201 = (_65 * 2.0) - vec3(1.0);
    float _219 = (1.0 - (_201.x * _201.x)) - (_201.y * _201.y);
    _201.z = sqrt(_14(_219));
    if (_66 == false)
    {
        _201.z = -_201.z;
    }
    return _201;
}

vec3 _74(vec3 _72, mat3 _73)
{
    return normalize(vec3(dot(_72, _73[0]), dot(_72, _73[1]), dot(_72, _73[2])));
}

float _21(vec4 _19, vec4 _20)
{
    return dot(_19, _20);
}

void _10(float _9)
{
    if (_9 < 0.0)
    {
        discard;
    }
}

vec2 _78(vec2 _77)
{
    return (vec2(1.0) - abs(_77.yx)) * vec2((_77.x >= 0.0) ? 1.0 : (-1.0), (_77.y >= 0.0) ? 1.0 : (-1.0));
}

vec2 _83(inout vec3 _81, bool _82)
{
    _81 /= vec3((abs(_81.x) + abs(_81.y)) + abs(_81.z));
    vec2 _290;
    if (_81.z >= 0.0)
    {
        _290 = _81.xy;
    }
    else
    {
        vec2 _296 = _81.xy;
        _290 = _78(_296);
    }
    _81 = vec3(_290.x, _290.y, _81.z);
    if (_82)
    {
        vec2 _311 = (_81.xy * 0.5) + vec2(0.5);
        _81 = vec3(_311.x, _311.y, _81.z);
    }
    return _81.xy;
}

float _43(float _42)
{
    return sqrt(_42);
}

float _86(float _85)
{
    float _321 = abs(_85);
    float _318 = _43(_321);
    float _325;
    if (_85 > 0.0)
    {
        _325 = _318;
    }
    else
    {
        _325 = -_318;
    }
    return (_325 * 0.5) + 0.5;
}

float _40(float _39)
{
    return _39 * _39;
}

void main()
{
    float _337 = 0.0;
    _340 _342 = _340(vec3(0.0), vec3(0.0), vec3(0.0), 0.0, 0.0, 0.0, vec3(0.0), vec3(0.0, 0.0, 1.0), vec3(0.0, 0.0, 1.0), vec3(0.0), vec3(0.0), 1.0, 1.0, vec3(0.0), vec3(0.0), vec4(0.0), vec4(0.0), mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0)), vec3(0.0), vec3(0.0), vec3(0.0), vec3(0.0), 0u, 0u, 0u, 0u, vec3(0.0), vec3(0.0), uvec4(0u), uvec4(0u), uvec4(0u), vec3(0.0), vec3(0.0), ivec3(0), vec4(0.0), vec4(0.0), vec4(0.0), 1.0, 0u);
    _342._m15 = _354;
    _342._m16 = gl_FragCoord;
    _342._m14 = _364._m4.xyz + _370.xyz;
    _342._m13 = normalize(-_370.xyz);
    _342._m17 = mat3(vec3(_382.xyz), vec3(_385.xyz), vec3(_388.xyz));
    _342._m34 = _406;
    _342._m35 = _410;
    _342._m36 = _414;
    uint _418 = 0u;
    vec4 _419 = vec4(0.0);
    vec4 _420 = vec4(0.0);
    vec4 _421 = vec4(0.0);
    vec4 _422 = vec4(0.0);
    vec4 _423 = vec4(0.0);
    _342._m0 = _421.xyz;
    _342._m2 = _422.xyz;
    _342._m1 = _420.xyz;
    _342._m9 = _419.xyz;
    _342._m3 = _419.w;
    _342._m6 = _423.wyz;
    vec2 _455 = _354.xy * _450._m2.xy;
    float _460 = _53(_445, _455).x * 4.0;
    _337 = _14(_460);
    _342._m2 = _450._m3.xxx;
    _342._m3 = _450._m3.y;
    _342._m6 = vec3(0.5, 0.5, 1.0);
    vec4 _489 = SAMPLE_TEXTURE1(_473, vec4(_354.xy, 0.0, -2.0).xy, vec4(_354.xy, 0.0, -2.0).w);
    vec3 _472 = _37(_489).xyz;
    _342._m0 = _472;
    _342._m11 = 1.0;
    uint _496 = uint((_499._m8.x > 0.0) ? 8 : 0);
    float _506 = 16.0;
    float _508 = 8.0;
    float _510 = 24.0;
    vec2 _519 = _342._m16.xy * _364._m6.xy;
    vec3 _512;
    _512 = vec3(_519.x, _519.y, _512.z);
    _512.y = 1.0 - _512.y;
    vec2 _532 = floor(_512.xy * vec2(_506, _508));
    _512 = vec3(_532.x, _532.y, _512.z);
    float _537 = _342._m16.z;
    vec4 _540 = _364._m7;
    float _543 = 1.0;
    bool _544 = false;
    float _535 = _62(_537, _540, _543, _544);
    float _546 = log2(max(1.0, _535 / _364._m8.z)) * _364._m8.w;
    _512.z = min(_510 - 1.0, floor(_546));
    uint _562 = uint((_512.x + (_512.y * _506)) + ((_512.z * _506) * _508));
    bool _578 = true;
    _578 = gl_FrontFacing;
    vec3 _583 = _342._m6;
    bool _586 = _578;
    _342._m7 = _67(_583, _586);
    vec3 _590 = _342._m7;
    mat3 _593 = _342._m17;
    _342._m6 = _74(_590, _593);
    uint _598 = 0u;
    uint _599 = 0u;
    uint _600 = 0u;
    uint _601 = 0u;
    uint _602 = 0u;
    uint _603 = 0u;
    int _605 = 256;
    _607 _609;
    _609._m0 = _614._m0[_562]._m0;
    _609._m1 = _614._m0[_562]._m1;
    int _623 = _609._m0 & (~(_609._m0 >> 31));
    int _632 = _609._m1 & (~(_609._m1 >> 31));
    _598 = uint((_623 >> 16) * _605);
    _599 = _598 + uint(_632 & 255);
    _600 = _598;
    _601 = _600 + uint((_632 >> 8) & 255);
    _602 = _598;
    _603 = _602 + uint((_632 >> 16) & 255);
    vec3 _665 = vec3(0.0);
    vec3 _666 = vec3(_342._m34.x, _342._m34.y, _342._m34.z);
    vec3 _674 = vec3(_342._m34.w, _342._m35.x, _342._m35.y);
    vec3 _682 = vec3(_342._m35.z, _342._m35.w, _342._m36.x);
    vec3 _690 = vec3(_342._m36.y, _342._m36.z, _342._m36.w);
    vec3 _698 = ((_666 - (_674 * _342._m6.y)) + (_682 * _342._m6.z)) - (_690 * _342._m6.x);
    float _721 = _499._m9.x * _364._m9.x;
    _665 += max(_698 * _14(_721), vec3(0.0));
    float _733;
    if (dot(_342._m10, vec3(1.0)) > 0.0)
    {
        _733 = -_342._m3;
    }
    else
    {
        _733 = _342._m3;
    }
    _342._m3 = _733;
    _342._m18 = _665;
    vec2 _747 = gl_FragCoord.xy * _364._m6.xy;
    _747.y = 1.0 - _747.y;
    vec4 _758 = vec4((_747.x * 2.0) - 1.0, (_747.y * 2.0) - 1.0, gl_FragCoord.z, 1.0);
    vec3 _771;
    _771.x = dot(_758, _364._m10);
    _771.y = dot(_758, _364._m11);
    _771.z = dot(_758, _364._m12);
    _771 /= vec3(dot(_758, _364._m13));
    float _795 = SAMPLE_TEXTURE(_796, _798.xy * vec2(_499._m10.w)).y;
    vec4 _815 = vec4(_499._m6.xyz, 1.0);
    vec4 _816 = _499._m1;
    vec3 _807;
    _807.x = _21(_815, _816);
    vec4 _828 = vec4(_499._m6.xyz, 1.0);
    vec4 _829 = _499._m2;
    _807.y = _21(_828, _829);
    vec4 _841 = vec4(_499._m6.xyz, 1.0);
    vec4 _842 = _499._m3;
    _807.z = _21(_841, _842);
    vec3 _847 = _807 - _771;
    float _851 = (_795 * _450._m4.x) + (1.0 - _450._m4.x);
    float _860 = length(_847) * _851;
    vec2 _865 = vec2(6.666666507720947265625, 10.0);
    float _869 = _860 - _499._m7.w;
    float _879 = _869 * _865.x;
    float _874 = _14(_879);
    float _886 = _869 * _865.y;
    float _881 = _14(_886);
    float _896 = (1.0 - _881) * _795;
    vec3 _888 = _499._m10.xyz * _14(_896);
    float _899 = _874;
    float _906 = ceil(_899 - 0.001000000047497451305389404296875);
    float _901 = _14(_906);
    float _911 = _901 - 9.9999997473787516355514526367188e-05;
    _10(_911);
    _342._m19 += _888;
    vec3 _928 = (_342._m18 * _342._m0) + _342._m10;
    _920 = vec4(_928.x, _928.y, _928.z, _920.w);
    vec3 _932 = _342._m6;
    bool _935 = false;
    vec2 _936 = _83(_932, _935);
    _931 = vec4(_936.x, _936.y, _931.z, _931.w);
    float _940 = _342._m2.x;
    float _944 = _342._m2.y;
    float _948 = _342._m2.z;
    float _952 = _342._m3;
    _939 = vec4(_43(_940), _43(_944), _43(_948), _86(_952));
    uint _957 = uint((_499._m8.x > 0.0) ? 8 : 0);
    uint _963 = uint(int(_957 > 0u));
    _963 |= 2u;
    float _971 = _342._m0.x;
    float _975 = _342._m0.y;
    float _979 = _342._m0.z;
    _970 = vec4(_43(_971), _43(_975), _43(_979), float(_963) / 255.0);
    vec3 _993 = _920.xyz + _499._m11.xyz;
    _920 = vec4(_993.x, _993.y, _993.z, _920.w);
    float _1002 = SAMPLE_TEXTURE(_997, _354.xy).x;
    float _1005 = _450._m3.z;
    float _1010 = mix(1.0, _40(_1002), _14(_1005));
    float _996 = _14(_1010);
    vec3 _1016 = _920.xyz * vec3(_996);
    _920 = vec4(_1016.x, _1016.y, _1016.z, _920.w);
}

