#version 450
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define UTEXTURE_2D utexture2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define UTEXTURE_2D utexture2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////
#extension GL_NV_shading_rate_image : require

struct _300
{
    vec3 _m0;
    vec3 _m1;
    vec3 _m2;
    float _m3;
    float _m4;
    float _m5;
    vec3 _m6;
    vec3 _m7;
    vec3 _m8;
    vec3 _m9;
    vec3 _m10;
    float _m11;
    float _m12;
    vec3 _m13;
    vec3 _m14;
    vec4 _m15;
    vec4 _m16;
    mat3 _m17;
    vec3 _m18;
    vec3 _m19;
    vec3 _m20;
    vec3 _m21;
    uint _m22;
    uint _m23;
    uint _m24;
    uint _m25;
    vec3 _m26;
    vec3 _m27;
    uvec4 _m28;
    uvec4 _m29;
    uvec4 _m30;
    vec3 _m31;
    vec3 _m32;
    ivec3 _m33;
    vec4 _m34;
    vec4 _m35;
    vec4 _m36;
    float _m37;
    uint _m38;
};

struct _1080
{
    int _m0;
    int _m1;
};

struct _1083
{
    int _m0;
    int _m1;
};


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 20, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(set = 0, binding = 0, std140) uniform _322_324
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
} _324;

layout(set = 2, binding = 0, std140) uniform _427_429
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
} _429;

layout(set = 1, binding = 0, std140) uniform _884_886
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
    vec4 _m22;
    vec4 _m23;
    vec4 _m24;
    vec4 _m25;
    vec4 _m26;
    vec4 _m27;
    vec4 _m28;
    vec4 _m29;
} _886;

layout(set = 0, binding = 13, std430) restrict readonly buffer _1085_1087
{
    _1083 _m0[];
} _1087;

layout(set = 0, binding = 1, std430) restrict readonly buffer _1430_1432
{
    vec4 _m0[];
} _1432;

layout(push_constant, std430) uniform _1426_1428
{
    int _m0;
    int _m1;
} _1428;

layout(set = 3, binding = 3) uniform TEXTURE_2D _455[8];
layout(set = 0, binding = 5) uniform sampler _462;
layout(set = 3, binding = 2) uniform TEXTURE_2D _508[8];
layout(set = 0, binding = 6) uniform sampler _512;
layout(set = 3, binding = 0) uniform TEXTURE_2D _523[8];
layout(set = 0, binding = 7) uniform sampler _527;
layout(set = 3, binding = 1) uniform TEXTURE_2D _538[8];
layout(set = 0, binding = 8) uniform sampler _542;
layout(set = 3, binding = 5) uniform TEXTURE_2D _551[8];
layout(set = 0, binding = 9) uniform sampler _555;
layout(set = 3, binding = 7) uniform TEXTURE_2D _564[8];
layout(set = 0, binding = 10) uniform sampler _568;
layout(set = 3, binding = 4) uniform TEXTURE_2D _577[8];
layout(set = 0, binding = 11) uniform sampler _581;
layout(set = 3, binding = 6) uniform TEXTURE_2D _590[8];
layout(set = 0, binding = 12) uniform sampler _594;
layout(set = 1, binding = 1) uniform SAMPLER_2D _894;
layout(set = 1, binding = 2) uniform SAMPLER_2D _899;
layout(set = 0, binding = 14) uniform SAMPLER_2D _1300;
layout(set = 0, binding = 3) uniform sampler3D _1436;
layout(set = 0, binding = 4) uniform sampler3D _1437;

layout(location = 2) in vec4 _314;
layout(location = 6) in vec4 _329;
layout(location = 3) in vec4 _341;
layout(location = 4) in vec4 _344;
layout(location = 5) in vec4 _347;
layout(location = 10) in vec4 _365;
layout(location = 11) in vec4 _369;
layout(location = 12) in vec4 _373;
layout(location = 14) flat in uvec3 _387;
layout(location = 15) in vec4 _390;
layout(location = 8) in vec4 _904;
layout(location = 0) out vec4 _1349;
layout(location = 1) out vec4 _1360;
layout(location = 2) out vec4 _1368;
layout(location = 3) out vec4 _1399;

float _104;

uvec4 _18(vec4 _17)
{
    return floatBitsToUint(_17);
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

float _21(float _20)
{
    if (_20 <= 0.040449999272823333740234375)
    {
        return _20 / 12.9200000762939453125;
    }
    else
    {
        return pow((_20 / 1.05499994754791259765625) + 0.0521326996386051177978515625, 2.400000095367431640625);
    }
}

vec3 _27(vec3 _26)
{
    float _106 = _26.x;
    vec3 _105;
    _105.x = _21(_106);
    float _112 = _26.y;
    _105.y = _21(_112);
    float _118 = _26.z;
    _105.z = _21(_118);
    return _105;
}

vec3 _30(vec3 _29)
{
    vec3 _127 = _29;
    return _27(_127);
}

float _42(float _38, vec4 _39, float _40, bool _41)
{
    float _136 = _39.w / (_38 + _39.z);
    return _136 * _40;
}

vec3 _47(vec3 _45, bool _46)
{
    vec3 _150 = (_45 * 2.0) - vec3(1.0);
    float _168 = (1.0 - (_150.x * _150.x)) - (_150.y * _150.y);
    _150.z = sqrt(_10(_168));
    if (_46 == false)
    {
        _150.z = -_150.z;
    }
    return _150;
}

vec3 _54(vec3 _52, mat3 _53)
{
    return normalize(vec3(dot(_52, _53[0]), dot(_52, _53[1]), dot(_52, _53[2])));
}

vec3 _60(vec3 _57, mat3 _58, bool _59)
{
    vec3 _205 = _57;
    bool _207 = _59;
    vec3 _204 = _47(_205, _207);
    vec3 _210 = _204;
    mat3 _212 = _58;
    return _54(_210, _212);
}

vec2 _66(vec2 _65)
{
    return (vec2(1.0) - abs(_65.yx)) * vec2((_65.x >= 0.0) ? 1.0 : (-1.0), (_65.y >= 0.0) ? 1.0 : (-1.0));
}

vec2 _71(inout vec3 _69, bool _70)
{
    _69 /= vec3((abs(_69.x) + abs(_69.y)) + abs(_69.z));
    vec2 _252;
    if (_69.z >= 0.0)
    {
        _252 = _69.xy;
    }
    else
    {
        vec2 _258 = _69.xy;
        _252 = _66(_258);
    }
    _69 = vec3(_252.x, _252.y, _69.z);
    if (_70)
    {
        vec2 _273 = (_69.xy * 0.5) + vec2(0.5);
        _69 = vec3(_273.x, _273.y, _69.z);
    }
    return _69.xy;
}

float _33(float _32)
{
    return sqrt(_32);
}

float _74(float _73)
{
    float _283 = abs(_73);
    float _280 = _33(_283);
    float _287;
    if (_73 > 0.0)
    {
        _287 = _280;
    }
    else
    {
        _287 = -_280;
    }
    return (_287 * 0.5) + 0.5;
}

void main()
{
    _300 _302 = _300(vec3(0.0), vec3(0.0), vec3(0.0), 0.0, 0.0, 0.0, vec3(0.0), vec3(0.0, 0.0, 1.0), vec3(0.0, 0.0, 1.0), vec3(0.0), vec3(0.0), 1.0, 1.0, vec3(0.0), vec3(0.0), vec4(0.0), vec4(0.0), mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0)), vec3(0.0), vec3(0.0), vec3(0.0), vec3(0.0), 0u, 0u, 0u, 0u, vec3(0.0), vec3(0.0), uvec4(0u), uvec4(0u), uvec4(0u), vec3(0.0), vec3(0.0), ivec3(0), vec4(0.0), vec4(0.0), vec4(0.0), 1.0, 0u);
    _302._m15 = _314;
    _302._m16 = gl_FragCoord;
    _302._m14 = _324._m0.xyz + _329.xyz;
    _302._m13 = normalize(-_329.xyz);
    _302._m17 = mat3(vec3(_341.xyz), vec3(_344.xyz), vec3(_347.xyz));
    _302._m34 = _365;
    _302._m35 = _369;
    _302._m36 = _373;
    uint _377 = 0u;
    vec4 _378 = vec4(0.0);
    vec4 _379 = vec4(0.0);
    vec4 _380 = vec4(0.0);
    vec4 _381 = vec4(0.0);
    vec4 _382 = vec4(0.0);
    uvec3 _385 = _387;
    vec3 _389 = _390.xyz;
    bool _397 = _385.y == 65535u;
    bool _403;
    if (_397)
    {
        _403 = _385.z == 65535u;
    }
    else
    {
        _403 = _397;
    }
    bool _393 = _403;
    bool _404 = !_393;
    bool _407 = _385.z != 65535u;
    uint _411 = _385.x & 7u;
    uint _422;
    if (_324._m2.x == 0.0)
    {
        _422 = _411;
    }
    else
    {
        vec4 _430 = _429._m2;
        uvec4 _426 = _18(_430);
        uint _434 = _426[_411 / 2u];
        uint _439 = 16u * (_411 & 1u);
        _422 = (_434 >> _439) & 65535u;
    }
    uint _448 = _422;
    float _450 = SAMPLE_TEXTURE(SAMPLER_2D(_455[_448], _462), _302._m15.zw).x;
    float _483 = pow(_450, 0.125) - 0.800000011920928955078125;
    vec2 _471 = vec2(1.0) / mix(vec2(1.0), vec2(gl_FragmentSizeNV), vec2(_10(_483) / 0.20000000298023223876953125));
    vec2 _491 = dFdx(_302._m15.zw) * _471.x;
    vec2 _499 = dFdy(_302._m15.zw) * _471.y;
    vec2 _507 = TEXTURE_GRAD(SAMPLER_2D(_508[_448], _512), _302._m15.zw, _491, _499).yx;
    vec3 _522 = SAMPLE_TEXTURE(SAMPLER_2D(_523[_448], _527), _302._m15.zw).xyz;
    vec3 _535 = vec3(0.039999999105930328369140625);
    _535 = SAMPLE_TEXTURE(SAMPLER_2D(_538[_448], _542), _302._m15.zw).xyz;
    float _550 = 1.0;
    _550 = SAMPLE_TEXTURE(SAMPLER_2D(_551[_448], _555), _302._m15.zw).x;
    float _563 = SAMPLE_TEXTURE(SAMPLER_2D(_564[_448], _568), _302._m15.zw).x;
    float _576 = SAMPLE_TEXTURE(SAMPLER_2D(_577[_448], _581), _302._m15.zw).x;
    vec3 _589 = SAMPLE_TEXTURE(SAMPLER_2D(_590[_448], _594), _302._m15.zw).xyz;
    _380 = vec4(_522.x, _522.y, _522.z, _380.w);
    _380.w = _507.y;
    _381 = vec4(_535.x, _535.y, _535.z, _381.w);
    _381.w = _576;
    _382 = vec4(_382.x, _507.x, _382.z, _507.y);
    _378.x = _563;
    _378.y = _550;
    _378.z = _576;
    _378.w = _450;
    _379 = vec4(_589.x, _589.y, _589.z, _379.w);
    uint _627 = 0u;
    vec4 _628 = vec4(0.0);
    vec4 _629 = vec4(0.0);
    vec4 _630 = vec4(0.0);
    vec4 _631 = vec4(0.0);
    vec4 _632 = vec4(0.0);
    uint _633 = _387.x & 7u;
    uint _643;
    if (_324._m2.x == 0.0)
    {
        _643 = _633;
    }
    else
    {
        vec4 _647 = _429._m2;
        uvec4 _646 = _18(_647);
        uint _651 = _646[_633 / 2u];
        uint _656 = 16u * (_633 & 1u);
        _643 = (_651 >> _656) & 65535u;
    }
    uint _664 = _643;
    vec4 _666 = vec4(_302._m15.xy, 0.0, _429._m3.x);
    vec3 _676 = SAMPLE_TEXTURE1(SAMPLER_2D(_523[_664], _527), _666.xy, _666.w).xyz;
    vec2 _688 = SAMPLE_TEXTURE1(SAMPLER_2D(_508[_664], _512), _666.xy, _666.w).yx;
    vec3 _700 = vec3(0.039999999105930328369140625);
    _700 = SAMPLE_TEXTURE1(SAMPLER_2D(_538[_664], _542), _666.xy, _666.w).xyz;
    float _712 = SAMPLE_TEXTURE1(SAMPLER_2D(_455[_664], _462), _666.xy, _666.w).x;
    float _724 = 1.0;
    _724 = SAMPLE_TEXTURE1(SAMPLER_2D(_551[_664], _555), _666.xy, _666.w).x;
    float _736 = SAMPLE_TEXTURE1(SAMPLER_2D(_564[_664], _568), _666.xy, _666.w).x;
    float _748 = SAMPLE_TEXTURE1(SAMPLER_2D(_577[_664], _581), _666.xy, _666.w).x;
    vec3 _760 = SAMPLE_TEXTURE1(SAMPLER_2D(_590[_664], _594), _666.xy, _666.w).xyz;
    _628 = vec4(_676.x, _676.y, _676.z, _628.w);
    _628.w = _688.y;
    _629 = vec4(_700.x, _700.y, _700.z, _629.w);
    _629.w = _748;
    _630 = vec4(_630.x, _688.x, _630.z, _688.y);
    _631.x = _736;
    _631.y = _724;
    _631.z = _748;
    _631.w = _712;
    _632 = vec4(_760.x, _760.y, _760.z, _632.w);
    _302._m8 = _630.wyz;
    float _807 = _378.y * _429._m4.x;
    _302._m4 = _10(_807);
    float _814;
    if (_429._m5.x > 0.0)
    {
        _814 = _381.x;
    }
    else
    {
        _814 = 0.0;
    }
    _302._m5 = _814;
    vec3 _825;
    if (_429._m5.x > 0.0)
    {
        _825 = vec3(_381.y);
    }
    else
    {
        _825 = _381.xyz;
    }
    _381 = vec4(_825.x, _825.y, _825.z, _381.w);
    float _845 = (1.0 - _302._m4) * _429._m6.x;
    _302._m12 = _10(_845);
    _302._m10 = vec3(_378.x) * _389;
    _302._m10 *= vec3(_324._m3.x);
    _302._m0 = _380.xyz;
    _302._m2 = _381.xyz;
    _302._m1 = _379.xyz;
    _302._m9 = _378.xyz;
    _302._m3 = _378.w;
    _302._m6 = _382.wyz;
    vec2 _881 = _314.xy * _886._m25.xy;
    vec4 _892 = SAMPLE_TEXTURE(_894, _881);
    vec4 _898 = SAMPLE_TEXTURE(_899, _881);
    float _909 = _904.x * 0.5;
    float _903 = 1.0 - _10(_909);
    float _915 = _903 * 2.0;
    float _922 = (_10(_915) - (1.0 - _892.w)) * 1.0;
    float _912 = _10(_922);
    float _931 = (_903 - (1.0 - _898.w)) * 1.0;
    float _924 = _10(_931);
    vec3 _935 = _892.xyz;
    _302._m0 = mix(_302._m0, _30(_935), vec3(_912));
    _302._m2 = mix(_302._m2, vec3(0.0199999995529651641845703125), vec3(_912));
    _302._m3 = mix(_302._m3, 0.64999997615814208984375, _912);
    _302._m6 = mix(_302._m6, _898.xyz, vec3(_924));
    uint _965 = uint((_886._m26.x > 0.0) ? 8 : 0);
    float _972 = 16.0;
    float _974 = 8.0;
    float _976 = 24.0;
    vec2 _985 = _302._m16.xy * _324._m4.xy;
    vec3 _978;
    _978 = vec3(_985.x, _985.y, _978.z);
    _978.y = 1.0 - _978.y;
    vec2 _998 = floor(_978.xy * vec2(_972, _974));
    _978 = vec3(_998.x, _998.y, _978.z);
    float _1002 = _302._m16.z;
    vec4 _1005 = _324._m5;
    float _1008 = 1.0;
    bool _1009 = false;
    float _1001 = _42(_1002, _1005, _1008, _1009);
    float _1011 = log2(max(1.0, _1001 / _324._m6.z)) * _324._m6.w;
    _978.z = min(_976 - 1.0, floor(_1011));
    uint _1027 = uint((_978.x + (_978.y * _972)) + ((_978.z * _972) * _974));
    bool _1043 = true;
    vec3 _1046 = _302._m6;
    bool _1049 = _1043;
    _302._m7 = _47(_1046, _1049);
    vec3 _1053 = _302._m7;
    mat3 _1056 = _302._m17;
    _302._m6 = _54(_1053, _1056);
    vec3 _1061 = _302._m8;
    mat3 _1064 = _302._m17;
    bool _1067 = _1043;
    _302._m8 = _60(_1061, _1064, _1067);
    uint _1071 = 0u;
    uint _1072 = 0u;
    uint _1073 = 0u;
    uint _1074 = 0u;
    uint _1075 = 0u;
    uint _1076 = 0u;
    int _1078 = 256;
    _1080 _1082;
    _1082._m0 = _1087._m0[_1027]._m0;
    _1082._m1 = _1087._m0[_1027]._m1;
    int _1096 = _1082._m0 & (~(_1082._m0 >> 31));
    int _1105 = _1082._m1 & (~(_1082._m1 >> 31));
    _1071 = uint((_1096 >> 16) * _1078);
    _1072 = _1071 + uint(_1105 & 255);
    _1073 = _1071;
    _1074 = _1073 + uint((_1105 >> 8) & 255);
    _1075 = _1071;
    _1076 = _1075 + uint((_1105 >> 16) & 255);
    vec3 _1138 = vec3(0.0);
    vec3 _1139 = vec3(_302._m34.x, _302._m34.y, _302._m34.z);
    vec3 _1147 = vec3(_302._m34.w, _302._m35.x, _302._m35.y);
    vec3 _1155 = vec3(_302._m35.z, _302._m35.w, _302._m36.x);
    vec3 _1163 = vec3(_302._m36.y, _302._m36.z, _302._m36.w);
    vec3 _1171 = ((_1139 - (_1147 * _302._m6.y)) + (_1155 * _302._m6.z)) - (_1163 * _302._m6.x);
    float _1195 = _886._m27.x * _324._m7.x;
    _1138 += max(_1171 * _10(_1195), vec3(0.0));
    vec3 _1201 = vec3(0.0);
    vec3 _1202 = vec3(_302._m34.x, _302._m34.y, _302._m34.z);
    vec3 _1210 = vec3(_302._m34.w, _302._m35.x, _302._m35.y);
    vec3 _1218 = vec3(_302._m35.z, _302._m35.w, _302._m36.x);
    vec3 _1226 = vec3(_302._m36.y, _302._m36.z, _302._m36.w);
    vec3 _1234 = ((_1202 - (_1210 * _302._m8.y)) + (_1218 * _302._m8.z)) - (_1226 * _302._m8.x);
    float _1257 = _886._m27.x * _324._m7.x;
    _1201 += max(_1234 * _10(_1257), vec3(0.0));
    _1138 = mix(_1138, _1201, vec3(_302._m4));
    float _1274;
    if (dot(_302._m10, vec3(1.0)) > 0.0)
    {
        _1274 = -_302._m3;
    }
    else
    {
        _1274 = _302._m3;
    }
    _302._m3 = _1274;
    _302._m18 = _1138;
    if (_886._m28.x < 1.0)
    {
        vec2 _1294 = gl_FragCoord.xy * 0.00390625;
        float _1299 = TEXTURE_LOD(_1300, vec4(_314.xy * _429._m7.xy, 0.0, 0.0).xy, vec4(_314.xy * _429._m7.xy, 0.0, 0.0).w).x;
        float _1333 = abs(clamp((_886._m28.x - (_1299 * 0.5)) - 0.100000001490116119384765625, -1.0, 0.0));
        _1299 = _10(_1333);
        _1299 *= 600.0;
        _302._m19 += (vec3(_1299) * vec3(1.0, 0.00999999977648258209228515625, 0.0));
    }
    vec3 _1357 = (_302._m18 * _302._m0) + _302._m10;
    _1349 = vec4(_1357.x, _1357.y, _1357.z, _1349.w);
    vec3 _1361 = _302._m6;
    bool _1364 = false;
    vec2 _1365 = _71(_1361, _1364);
    _1360 = vec4(_1365.x, _1365.y, _1360.z, _1360.w);
    float _1369 = _302._m2.x;
    float _1373 = _302._m2.y;
    float _1377 = _302._m2.z;
    float _1381 = _302._m3;
    _1368 = vec4(_33(_1369), _33(_1373), _33(_1377), _74(_1381));
    uint _1386 = uint((_886._m26.x > 0.0) ? 8 : 0);
    uint _1392 = uint(int(_1386 > 0u));
    _1392 |= 2u;
    float _1400 = _302._m0.x;
    float _1404 = _302._m0.y;
    float _1408 = _302._m0.z;
    _1399 = vec4(_33(_1400), _33(_1404), _33(_1408), float(_1392) / 255.0);
    vec3 _1423 = _1349.xyz + _886._m29.xyz;
    _1349 = vec4(_1423.x, _1423.y, _1423.z, _1349.w);
}

