#version 450
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define UTEXTURE_2D utexture2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define UTEXTURE_2D utexture2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////
layout(early_fragment_tests) in;

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
 
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 30, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};


   

struct _691
{
    vec3 _m0;
    vec3 _m1;
    vec3 _m2;
    float _m3;
    float _m4;
    float _m5;
    vec3 _m6;
    vec3 _m7;
    vec3 _m8;
    vec3 _m9;
    vec3 _m10;
    float _m11;
    float _m12;
    vec3 _m13;
    vec3 _m14;
    vec4 _m15;
    vec4 _m16;
    mat3 _m17;
    vec3 _m18;
    vec3 _m19;
    vec3 _m20;
    vec3 _m21;
    uint _m22;
    uint _m23;
    uint _m24;
    uint _m25;
    vec3 _m26;
    vec3 _m27;
    uvec4 _m28;
    uvec4 _m29;
    uvec4 _m30;
    vec3 _m31;
    vec3 _m32;
    ivec3 _m33;
    vec4 _m34;
    vec4 _m35;
    vec4 _m36;
    float _m37;
    uint _m38;
};

struct _1597
{
    int _m0;
    int _m1;
};

struct _1600
{
    int _m0;
    int _m1;
};

struct _1700
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    uvec2 _m3;
    uvec2 _m4;
    uvec2 _m5;
    uint _m6;
    uint _m7;
    uint _m8;
    uint _m9;
    uint _m10;
    uint _m11;
};

struct _2498
{
    vec3 _m0;
    uint _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    uvec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    uint _m11;
    uint _m12;
    float _m13;
    uint _m14;
};

struct _3273
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
};

struct _3968
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    uint _m3;
    uint _m4;
    uint _m5;
    uint _m6;
};

layout(set = 0, binding = 0, std140) uniform _723_725
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
} _725;

layout(set = 2, binding = 0, std140) uniform _829_831
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
} _831;

layout(set = 1, binding = 0, std140) uniform _982_984
{
    vec4 _m0;
    vec4 _m1;
    vec4 _m2;
    vec4 _m3;
    vec4 _m4;
    vec4 _m5;
    vec4 _m6;
    vec4 _m7;
    vec4 _m8;
    vec4 _m9;
    vec4 _m10;
    vec4 _m11;
    vec4 _m12;
    vec4 _m13;
    vec4 _m14;
    vec4 _m15;
    vec4 _m16;
    vec4 _m17;
    vec4 _m18;
    vec4 _m19;
    vec4 _m20;
    vec4 _m21;
} _984;

layout(set = 0, binding = 13, std430) restrict readonly buffer _1602_1604
{
    _1600 _m0[];
} _1604;

layout(set = 0, binding = 14, std430) restrict readonly buffer _1675_1677
{
    uint _m0[];
} _1677;

layout(set = 0, binding = 15, std140) uniform _1705_1707
{
    vec4 _m0[4096];
} _1707;

layout(set = 0, binding = 16, std140) uniform _1725_1727
{
    vec4 _m0[4096];
} _1727;

layout(set = 0, binding = 17, std140) uniform _1777_1779
{
    vec4 _m0[4096];
} _1779;

layout(set = 0, binding = 19, std140) uniform _2502_2504
{
    vec4 _m0[4096];
} _2504;

layout(set = 0, binding = 20, std140) uniform _2541_2543
{
    vec4 _m0[4096];
} _2543;

layout(set = 0, binding = 21, std140) uniform _2610_2612
{
    vec4 _m0[3072];
} _2612;

layout(set = 0, binding = 23, std140) uniform _3277_3279
{
    vec4 _m0[4095];
} _3279;

layout(set = 0, binding = 25, std140) uniform _3972_3974
{
    vec4 _m0[4096];
} _3974;

layout(push_constant, std430) uniform _4311_4313
{
    int _m0;
    int _m1;
} _4313;

layout(set = 3, binding = 3) uniform TEXTURE_2D _856[8];
layout(set = 0, binding = 2) uniform sampler _863;
layout(set = 3, binding = 2) uniform TEXTURE_2D _871[8];
layout(set = 0, binding = 3) uniform sampler _875;
layout(set = 3, binding = 0) uniform TEXTURE_2D _883[8];
layout(set = 0, binding = 4) uniform sampler _887;
layout(set = 3, binding = 1) uniform TEXTURE_2D _897[8];
layout(set = 0, binding = 5) uniform sampler _901;
layout(set = 3, binding = 7) uniform TEXTURE_2D _910[8];
layout(set = 0, binding = 6) uniform sampler _914;
layout(set = 3, binding = 4) uniform TEXTURE_2D _922[8];
layout(set = 0, binding = 7) uniform sampler _926;
layout(set = 3, binding = 6) uniform TEXTURE_2D _934[8];
layout(set = 0, binding = 8) uniform sampler _938;
layout(set = 0, binding = 9) uniform SAMPLER_2D _1181;
layout(set = 0, binding = 10) uniform SAMPLER_2D _1190;
layout(set = 0, binding = 11) uniform SAMPLER_2D _1236;
layout(set = 0, binding = 12, r32f) uniform writeonly image2D _1471;
layout(set = 0, binding = 18) uniform SAMPLER_2D _1999;
layout(set = 0, binding = 22) uniform SAMPLER_2D _2836;
layout(set = 0, binding = 24) uniform sampler2DShadow _3600;
layout(set = 0, binding = 26) uniform SAMPLER_2D _4113;
layout(set = 3, binding = 5) uniform TEXTURE_2D _4310[8];

layout(location = 2) in vec4 _705;
layout(location = 5) in vec4 _712;
layout(location = 3) in vec4 _715;
layout(location = 4) in vec4 _738;
layout(location = 14) flat in uvec3 _790;
layout(location = 15) in vec4 _793;
layout(location = 6) in vec4 _971;
layout(location = 0) out vec4 _4268;
layout(location = 1) out vec4 _4276;
layout(location = 2) out vec4 _4284;

uvec4 _44(vec4 _43)
{
    return floatBitsToUint(_43);
}

float _29(vec2 _27, vec2 _28)
{
    return dot(_27, _28);
}

vec4 _116(SAMPLER_2D _112, vec2 _113, vec2 _114, vec2 _115)
{
    return TEXTURE_GRAD(_112, _113, _114, _115);
}

vec4 _109(SAMPLER_2D _107, vec2 _108)
{
    return SAMPLE_TEXTURE(_107, _108);
}

float _10(float _9)
{
    return clamp(_9, 0.0, 1.0);
}

float _35(uint _34)
{
    return uintBitsToFloat(_34);
}

float _141(float _137, vec4 _138, float _139, bool _140)
{
    float _546 = _138.w / (_137 + _138.z);
    return _546 * _139;
}

vec3 _146(vec3 _144, bool _145)
{
    vec3 _559 = (_144 * 2.0) - vec3(1.0);
    float _576 = (1.0 - (_559.x * _559.x)) - (_559.y * _559.y);
    _559.z = sqrt(_10(_576));
    if (_145 == false)
    {
        _559.z = -_559.z;
    }
    return _559;
}

vec3 _153(vec3 _151, mat3 _152)
{
    return normalize(vec3(dot(_151, _152[0]), dot(_151, _152[1]), dot(_151, _152[2])));
}

uint _39(float _38)
{
    return floatBitsToUint(_38);
}

float _55(float _52, float _53, float _54)
{
    return min(_52, min(_53, _54));
}

float _50(float _47, float _48, float _49)
{
    return max(_47, max(_48, _49));
}

vec4 _88(uint _87)
{
    return unpackUnorm4x8(_87).wzyx;
}

vec4 _101(uvec2 _100)
{
    return vec4(float((_100.x >> uint(16)) & 65535u), float(_100.x & 65535u), float((_100.y >> uint(16)) & 65535u), float(_100.y & 65535u)) * 3.0518509447574615478515625e-05;
}

float _64(float _63)
{
    return _63 * ((_63 * ((_63 * 0.305306017398834228515625) + 0.6821711063385009765625)) + 0.01252287812530994415283203125);
}

vec4 _91(uint _90)
{
    return vec4(float((_90 >> uint(24)) & 255u), float((_90 >> uint(16)) & 255u), float((_90 >> uint(8)) & 255u), float(_90 & 255u));
}

vec3 _67(vec3 _66)
{
    float _275 = _66.x;
    vec3 _274;
    _274.x = _64(_275);
    float _281 = _66.y;
    _274.y = _64(_281);
    float _287 = _66.z;
    _274.z = _64(_287);
    return _274;
}

vec4 _70(vec4 _69)
{
    vec3 _297 = _69.xyz;
    vec4 _296 = vec4(_67(_297), 1.0);
    float _305 = _69.w;
    _296.w = _64(_305);
    return _296;
}

float _81(float _80)
{
    return (step(0.0, _80) * 2.0) - 1.0;
}

vec4 _22(vec4 _21)
{
    return clamp(_21, vec4(0.0), vec4(1.0));
}

vec3 _95(uint _94)
{
    return vec3(float((_94 >> uint(21)) & 2047u), float((_94 >> uint(10)) & 2047u), float(_94 & 1023u)) / vec3(2047.0, 2047.0, 1023.0);
}

uint _61(float _58, float _59, float _60)
{
    bool _220 = abs(_60) >= abs(_58);
    bool _228;
    if (_220)
    {
        _228 = abs(_60) >= abs(_59);
    }
    else
    {
        _228 = _220;
    }
    if (_228)
    {
        return uint((_60 < 0.0) ? 5 : 4);
    }
    if (abs(_59) >= abs(_58))
    {
        return uint((_59 < 0.0) ? 3 : 2);
    }
    return uint(int(_58 < 0.0));
}

float _73(float _72)
{
    return exp2(_72);
}

vec3 _119(uint _118)
{
    uint _420 = _118;
    vec4 _419 = _88(_420);
    float _431 = (_419.w * 255.0) - 128.0;
    return _419.xyz * _73(_431);
}

float _78(float _76, float _77)
{
    return pow(_76, _77);
}

vec3 _16(vec3 _15)
{
    return clamp(_15, vec3(0.0), vec3(1.0));
}

vec3 _124(vec3 _122, float _123)
{
    float _443 = 50.0 * dot(_122, vec3(0.33329999446868896484375));
    float _436 = _10(_443);
    float _452 = 1.0 - _123;
    float _455 = _10(_452);
    float _456 = 5.0;
    vec3 _460 = _122 + ((vec3(_436) - _122) * _78(_455, _456));
    return _16(_460);
}

vec3 _132(vec3 _127, vec3 _128, vec3 _129, vec3 _130, float _131)
{
    vec3 _464 = normalize(_128 + _129);
    float _469 = 1.0 - (_131 * 0.800000011920928955078125);
    _469 *= _469;
    _469 *= _469;
    float _480 = _469 * _469;
    float _488 = dot(_127, _464);
    float _484 = _10(_488);
    float _490 = ((_484 * _484) * (_480 - 1.0)) + 1.0;
    _490 = _480 / ((_490 * _490) + 9.9999999392252902907785028219223e-09);
    float _509 = dot(_127, _128);
    float _505 = (_10(_509) * (1.0 - _469)) + _469;
    float _520 = dot(_127, _129);
    float _516 = (_10(_520) * (1.0 - _469)) + _469;
    _490 /= (((4.0 * _505) * _516) + 9.9999999392252902907785028219223e-09);
    vec3 _538 = _130;
    float _540 = dot(_129, _464);
    return _124(_538, _540) * _490;
}

vec2 _157(vec2 _156)
{
    return (vec2(1.0) - abs(_156.yx)) * vec2((_156.x >= 0.0) ? 1.0 : (-1.0), (_156.y >= 0.0) ? 1.0 : (-1.0));
}

vec2 _162(inout vec3 _160, bool _161)
{
    _160 /= vec3((abs(_160.x) + abs(_160.y)) + abs(_160.z));
    vec2 _640;
    if (_160.z >= 0.0)
    {
        _640 = _160.xy;
    }
    else
    {
        vec2 _649 = _160.xy;
        _640 = _157(_649);
    }
    _160 = vec3(_640.x, _640.y, _160.z);
    if (_161)
    {
        vec2 _664 = (_160.xy * 0.5) + vec2(0.5);
        _160 = vec3(_664.x, _664.y, _160.z);
    }
    return _160.xy;
}

float _84(float _83)
{
    return sqrt(_83);
}

float _165(float _164)
{
    float _674 = abs(_164);
    float _671 = _84(_674);
    float _676;
    if (_164 > 0.0)
    {
        _676 = _671;
    }
    else
    {
        _676 = -_671;
    }
    return (_676 * 0.5) + 0.5;
}

void main()
{
    _691 _693 = _691(vec3(0.0), vec3(0.0), vec3(0.0), 0.0, 0.0, 0.0, vec3(0.0), vec3(0.0, 0.0, 1.0), vec3(0.0, 0.0, 1.0), vec3(0.0), vec3(0.0), 1.0, 1.0, vec3(0.0), vec3(0.0), vec4(0.0), vec4(0.0), mat3(vec3(1.0, 0.0, 0.0), vec3(0.0, 1.0, 0.0), vec3(0.0, 0.0, 1.0)), vec3(0.0), vec3(0.0), vec3(0.0), vec3(0.0), 0u, 0u, 0u, 0u, vec3(0.0), vec3(0.0), uvec4(0u), uvec4(0u), uvec4(0u), vec3(0.0), vec3(0.0), ivec3(0), vec4(0.0), vec4(0.0), vec4(0.0), 1.0, 0u);
    _693._m15 = _705;
    _693._m16 = gl_FragCoord;
    vec3 _711 = vec3(_712.zw, _715.w);
    _693._m14 = _725._m0.xyz + _711;
    vec3 _733 = normalize(_715.xyz);
    vec3 _737 = normalize(_738.xyz);
    vec3 _742 = normalize(cross(_733, _737) * sign(_738.w));
    _693._m17 = mat3(vec3(_737.x, _742.x, _733.x), vec3(_737.y, _742.y, _733.y), vec3(_737.z, _742.z, _733.z));
    _693._m13 = normalize(-_711);
    uint _780 = 0u;
    vec4 _781 = vec4(0.0);
    vec4 _782 = vec4(0.0);
    vec4 _783 = vec4(0.0);
    vec4 _784 = vec4(0.0);
    vec4 _785 = vec4(0.0);
    uvec3 _788 = _790;
    vec3 _792 = _793.xyz;
    bool _799 = _788.y == 65535u;
    bool _805;
    if (_799)
    {
        _805 = _788.z == 65535u;
    }
    else
    {
        _805 = _799;
    }
    bool _796 = _805;
    bool _806 = !_796;
    bool _809 = _788.z != 65535u;
    uint _813 = _788.x & 7u;
    uint _824;
    if (_725._m1.x == 0.0)
    {
        _824 = _813;
    }
    else
    {
        vec4 _832 = _831._m3;
        uvec4 _828 = _44(_832);
        uint _836 = _828[_813 / 2u];
        uint _841 = 16u * (_813 & 1u);
        _824 = (_836 >> _841) & 65535u;
    }
    uint _850 = _824;
    float _852 = texture(SAMPLER_2D(_856[_850], _863), _705.zw).x;
    vec2 _870 = texture(SAMPLER_2D(_871[_850], _875), _705.zw).yx;
    vec3 _882 = texture(SAMPLER_2D(_883[_850], _887), _705.zw).xyz;
    vec3 _894 = vec3(0.039999999105930328369140625);
    _894 = texture(SAMPLER_2D(_897[_850], _901), _705.zw).xyz;
    float _908 = 1.0;
    float _909 = texture(SAMPLER_2D(_910[_850], _914), _705.zw).x;
    float _921 = texture(SAMPLER_2D(_922[_850], _926), _705.zw).x;
    vec3 _933 = texture(SAMPLER_2D(_934[_850], _938), _705.zw).xyz;
    _783 = vec4(_882.x, _882.y, _882.z, _783.w);
    _783.w = _870.y;
    _784 = vec4(_894.x, _894.y, _894.z, _784.w);
    _784.w = _921;
    _785 = vec4(_785.x, _870.x, _785.z, _870.y);
    _781.x = _909;
    _781.y = _908;
    _781.z = _921;
    _781.w = _852;
    _782 = vec4(_933.x, _933.y, _933.z, _782.w);
    vec3 _970 = _971.xyz;
    _693._m10 = (((vec3(_781.x * _781.x) * _970) * _984._m0.xyz) * _984._m1.xxx) * mix(_783.xyz, vec3(1.0), vec3(_984._m0.w));
    _693._m10 *= vec3(_725._m2.x);
    uint _1009 = 0u;
    _693._m15.x = (_693._m15.x * _984._m3.x) + _984._m3.z;
    _693._m15.y = (_693._m15.y * _984._m3.y) + _984._m3.w;
    float _1028 = _725._m3.z;
    float _1031 = _725._m4.z;
    vec2 _1034 = _693._m15.xy * _1028;
    vec2 _1040 = dFdx(_1034);
    vec2 _1043 = dFdy(_1034);
    vec2 _1047 = _1040;
    vec2 _1049 = _1040;
    float _1046 = _29(_1047, _1049);
    vec2 _1053 = _1043;
    vec2 _1055 = _1043;
    float _1052 = _29(_1053, _1055);
    float _1058 = 0.5 * log2(max(_1046, _1052));
    float _1064 = 0.5 * log2(min(_1046, _1052));
    float _1070 = _1058 - min(_1031, _1058 - _1064);
    float _1078 = _1070;
    float _1080 = _725._m3.y;
    float _1083 = _725._m4.y;
    uvec2 _1086 = uvec2(_693._m15.xy * _1080);
    uint _1093 = uint(min(_725._m4.w, max(0.0, _1070) + _1083));
    uint _1102 = uint(_725._m3.x);
    _1009 = _1086.x & 255u;
    _1009 |= ((_1086.y & 255u) << uint(8));
    _1009 |= ((_1086.x >> uint(8)) << uint(16));
    _1009 |= ((_1086.y >> uint(8)) << uint(24));
    _1009 |= (_1093 << uint(19));
    _1009 |= (_1102 << uint(27));
    vec3 _1194;
    if (_725._m5.y != 0.0)
    {
        float _1142 = fract(_1078);
        float _1145 = 0.375;
        float _1147 = 0.625;
        bool _1154;
        float _1155;
        float _1158;
        if (_1142 <= _1145)
        {
            _1154 = false;
            _1155 = _1078 - 0.5;
            _1158 = 0.0;
        }
        else
        {
            if (_1142 >= _1147)
            {
                _1154 = false;
                _1155 = _1078 + 0.5;
                _1158 = 0.0;
            }
            else
            {
                _1154 = true;
                _1155 = _1078 - 0.5;
                _1158 = _1078 + 0.5;
            }
        }
        vec4 _1173 = vec4(_693._m15.x, _693._m15.y, 0.0, _1155);
        vec2 _1180 = TEXTURE_LOD(_1181, _1173.xy, _1173.w).xy;
        vec4 _1189 = SAMPLE_TEXTURE(_1190, _1180);
        _1194.x = (_693._m15.x * _1189.x) + _1189.z;
        _1194.y = (_693._m15.y * (_1189.x * _725._m6.x)) + _1189.w;
        _1194.z = _1189.y;
        vec2 _1220 = dFdx(_693._m15.xy) * _1194.z;
        vec2 _1228 = dFdy(_693._m15.xy) * _1194.z;
        vec2 _1237 = _1194.xy;
        vec2 _1240 = _1220;
        vec2 _1242 = _1228;
        vec3 _1245 = _116(_1236, _1237, _1240, _1242).xyz;
        _781 = vec4(_1245.x, _1245.y, _1245.z, _781.w);
        vec2 _1248 = _1194.xy;
        vec3 _1252 = _109(_1236, _1248).xyz;
        _781 = vec4(_1252.x, _1252.y, _1252.z, _781.w);
        if (_1154)
        {
            vec4 _1258 = vec4(_693._m15.x, _693._m15.y, 0.0, _1158);
            vec2 _1265 = TEXTURE_LOD(_1181, _1258.xy, _1258.w).xy;
            vec4 _1273 = SAMPLE_TEXTURE(_1190, _1265);
            _1194.x = (_693._m15.x * _1273.x) + _1273.z;
            _1194.y = (_693._m15.y * (_1273.x * _725._m6.x)) + _1273.w;
            _1194.z = _1273.y;
            vec2 _1301 = dFdx(_693._m15.xy) * _1194.z;
            vec2 _1309 = dFdy(_693._m15.xy) * _1194.z;
            vec2 _1318 = _1194.xy;
            vec2 _1321 = _1301;
            vec2 _1323 = _1309;
            vec3 _1326 = _116(_1236, _1318, _1321, _1323).xyz;
            vec4 _1317;
            _1317 = vec4(_1326.x, _1326.y, _1326.z, _1317.w);
            vec2 _1329 = _1194.xy;
            vec3 _1333 = _109(_1236, _1329).xyz;
            _1317 = vec4(_1333.x, _1333.y, _1333.z, _1317.w);
            float _1336 = 0.0;
            float _1337 = 0.375;
            float _1342 = (_1142 - _1337) * 4.0;
            _1336 = _10(_1342);
            vec3 _1350 = mix(_781.xyz, _1317.xyz, vec3(_1336));
            _1317 = vec4(_1350.x, _1350.y, _1350.z, _1317.w);
        }
    }
    else
    {
        vec4 _1354 = vec4(_693._m15.x, _693._m15.y, 0.0, _1078 - 0.5);
        vec2 _1362 = TEXTURE_LOD(_1181, _1354.xy, _1354.w).xy;
        vec4 _1370 = SAMPLE_TEXTURE(_1190, _1362);
        _1194.x = (_693._m15.x * _1370.x) + _1370.z;
        _1194.y = (_693._m15.y * (_1370.x * _725._m6.x)) + _1370.w;
        _1194.z = _1370.y;
        vec2 _1398 = dFdx(_693._m15.xy) * _1194.z;
        vec2 _1406 = dFdy(_693._m15.xy) * _1194.z;
        vec2 _1414 = _1194.xy;
        vec2 _1417 = _1398;
        vec2 _1419 = _1406;
        vec3 _1422 = _116(_1236, _1414, _1417, _1419).xyz;
        _781 = vec4(_1422.x, _1422.y, _1422.z, _781.w);
        vec2 _1425 = _1194.xy;
        vec3 _1429 = _109(_1236, _1425).xyz;
        _781 = vec4(_1429.x, _1429.y, _1429.z, _781.w);
    }
    vec2 _1432 = vec2(160.0, 90.0);
    vec2 _1436 = _1432 * _725._m7.zw;
    vec2 _1443 = (gl_FragCoord.xy * _725._m7.zw) * _1432;
    bool _1457 = fract(_1443.x) < _1436.x;
    bool _1466;
    if (_1457)
    {
        _1466 = fract(_1443.y) < _1436.y;
    }
    else
    {
        _1466 = _1457;
    }
    if (_1466)
    {
        uint _1476 = _1009;
        imageStore(_1471, ivec2(_1443), vec4(_35(_1476), 0.0, 0.0, 0.0));
    }
    _780 = _1009;
    _693._m0 = _783.xyz;
    _693._m2 = _784.xyz;
    _693._m1 = _782.xyz;
    _693._m9 = _781.xyz;
    _693._m3 = _781.w;
    _693._m6 = _785.wyz;
    uint _1500 = 8u;
    float _1501 = 16.0;
    float _1503 = 8.0;
    float _1505 = 24.0;
    vec2 _1514 = _693._m16.xy * _725._m7.xy;
    vec3 _1507;
    _1507 = vec3(_1514.x, _1514.y, _1507.z);
    _1507.y = 1.0 - _1507.y;
    
      // FIX FOR DECALS CLIPPING
    //clusterCoordinate.x -= vk3d_params[VIEW].stereo.x * 0.5;
   _1507.x -= vk3d_params[VIEW].stereo.x * 0.5;
   
    
    
    
    
    vec2 _1527 = floor(_1507.xy * vec2(_1501, _1503));
    _1507 = vec3(_1527.x, _1527.y, _1507.z);
    float _1531 = _693._m16.z;
    vec4 _1534 = _725._m8;
    float _1537 = 1.0;
    bool _1538 = false;
    float _1530 = _141(_1531, _1534, _1537, _1538);
    float _1540 = log2(max(1.0, _1530 / _725._m9.z)) * _725._m9.w;
    _1507.z = min(_1505 - 1.0, floor(_1540));
    uint _1556 = uint((_1507.x + (_1507.y * _1501)) + ((_1507.z * _1501) * _1503));
    bool _1572 = true;
    vec3 _1573 = _693._m6;
    bool _1576 = _1572;
    _693._m7 = _146(_1573, _1576);
    vec3 _1580 = _693._m7;
    mat3 _1583 = _693._m17;
    _693._m6 = _153(_1580, _1583);
    uint _1588 = 0u;
    uint _1589 = 0u;
    uint _1590 = 0u;
    uint _1591 = 0u;
    uint _1592 = 0u;
    uint _1593 = 0u;
    int _1595 = 256;
    _1597 _1599;
    _1599._m0 = _1604._m0[_1556]._m0;
    _1599._m1 = _1604._m0[_1556]._m1;
    int _1613 = _1599._m0 & (~(_1599._m0 >> 31));
    int _1622 = _1599._m1 & (~(_1599._m1 >> 31));
    _1588 = uint((_1613 >> 16) * _1595);
    _1589 = _1588 + uint(_1622 & 255);
    _1590 = _1588;
    _1591 = _1590 + uint((_1622 >> 8) & 255);
    _1592 = _1588;
    _1593 = _1592 + uint((_1622 >> 16) & 255);
    vec3 _1655 = dFdx(_693._m14);
    vec3 _1659 = dFdy(_693._m14);
    uint _1663 = _1590;
    _1700 _1702;
    vec3 _2053;
    float _2186;
    while (_1663 < _1591)
    {
        uint _1673 = _1677._m0[_1663];
        uint _1682 = (_1673 >> uint(12)) & 4095u;
        uint _1688 = _1682;
        if (_1688 >= _1682)
        {
            _1663++;
        }
        int _1697 = 2;
        int _1698 = 2;
        int _1699 = 2;
        _1702._m0 = _1707._m0[(uint(_1697) * _1688) + 0u];
        _1702._m1 = _1707._m0[(uint(_1697) * _1688) + 1u];
        _1702._m2 = _1727._m0[(uint(_1698) * _1688) + 0u];
        float _1741 = _1727._m0[(uint(_1698) * _1688) + 1u].x;
        _1702._m3.x = _39(_1741);
        float _1751 = _1727._m0[(uint(_1698) * _1688) + 1u].y;
        _1702._m3.y = _39(_1751);
        float _1761 = _1727._m0[(uint(_1698) * _1688) + 1u].z;
        _1702._m4.x = _39(_1761);
        float _1771 = _1727._m0[(uint(_1698) * _1688) + 1u].w;
        _1702._m4.y = _39(_1771);
        float _1785 = _1779._m0[(uint(_1699) * _1688) + 0u].x;
        _1702._m5.x = _39(_1785);
        float _1795 = _1779._m0[(uint(_1699) * _1688) + 0u].y;
        _1702._m5.y = _39(_1795);
        float _1805 = _1779._m0[(uint(_1699) * _1688) + 0u].z;
        _1702._m6 = _39(_1805);
        float _1815 = _1779._m0[(uint(_1699) * _1688) + 0u].w;
        _1702._m7 = _39(_1815);
        float _1825 = _1779._m0[(uint(_1699) * _1688) + 1u].x;
        _1702._m8 = _39(_1825);
        float _1835 = _1779._m0[(uint(_1699) * _1688) + 1u].y;
        _1702._m9 = _39(_1835);
        float _1845 = _1779._m0[(uint(_1699) * _1688) + 1u].z;
        _1702._m10 = _39(_1845);
        float _1856 = _1779._m0[(uint(_1699) * _1688) + 1u].w;
        _1702._m11 = _39(_1856);
        vec4 _1861 = _1702._m0;
        vec4 _1864 = _1702._m2;
        vec4 _1867 = _1702._m1;
        vec4 _1870 = vec4(_693._m14, 1.0);
        vec3 _1877 = vec3(dot(_1870, _1861), dot(_1870, _1867), dot(_1870, _1864));
        float _1888 = 0.0039215688593685626983642578125;
        float _1890 = _1877.x;
        float _1893 = _1877.y;
        float _1896 = _1877.z;
        bool _1901 = _55(_1890, _1893, _1896) <= _1888;
        bool _1918;
        if (!_1901)
        {
            float _1905 = _1877.x;
            float _1908 = _1877.y;
            float _1911 = _1877.z;
            _1918 = _50(_1905, _1908, _1911) >= (1.0 - _1888);
        }
        else
        {
            _1918 = _1901;
        }
        if (_1918)
        {
            continue;
        }
        uint _1922 = _1702._m11;
        bool _1926 = _1500 != 0u;
        bool _1933;
        if (_1926)
        {
            _1933 = (_1922 & 512u) != 0u;
        }
        else
        {
            _1933 = _1926;
        }
        bool _1946;
        if (!_1933)
        {
            bool _1938 = _1500 == 0u;
            bool _1945;
            if (_1938)
            {
                _1945 = (_1922 & 1024u) != 0u;
            }
            else
            {
                _1945 = _1938;
            }
            _1946 = _1945;
        }
        else
        {
            _1946 = _1933;
        }
        if (_1946)
        {
            continue;
        }
        vec2 _1950 = vec2(dot(_1655, _1861.xyz), dot(_1655, _1867.xyz));
        vec2 _1960 = vec2(dot(_1659, _1861.xyz), dot(_1659, _1867.xyz));
        float _1970 = 1.0;
        float _1971 = 1.0;
        vec3 _1972 = vec3(0.5, 0.5, 1.0);
        vec3 _1974 = vec3(0.0, 0.0, 1.0);
        uint _1975 = _1702._m7;
        uint _1979 = _1702._m9;
        vec4 _1978 = _88(_1979);
        uvec2 _1984 = _1702._m5;
        vec4 _1983 = _101(_1984);
        vec2 _1988 = _1950 * _1983.xy;
        vec2 _1993 = _1960 * _1983.xy;
        vec2 _2008 = (_1877.xy * _1983.xy) + _1983.zw;
        vec2 _2009 = _1988;
        vec2 _2011 = _1993;
        vec4 _1998 = _116(_1999, _2008, _2009, _2011);
        vec2 _2014 = (_1998.xy * 2.0) - vec2(1.0);
        float _2025 = 1.0 - dot(_2014, _2014);
        _1972 = vec3(_2014, sqrt(_10(_2025)));
        _1974 = _1972;
        _1970 = _1998.z;
        float _2034 = _1998.w;
        _1971 = _64(_2034);
        bool _2041 = _1971 <= (4.0 * _1888);
        bool _2048;
        if (_2041)
        {
            _2048 = _1978.w <= _1888;
        }
        else
        {
            _2048 = _2041;
        }
        if (_2048)
        {
            continue;
        }
        _1972 = _1974;
        if ((_1922 & 128u) != 0u)
        {
            _2053 = vec3(-_1972.x, -_1972.y, _1972.z);
        }
        else
        {
            _2053 = _1972;
        }
        _1972 = _2053;
        uint _2072 = _1702._m8;
        uint _2076 = _2072;
        float _2075 = 1.0 + (_91(_2076).w * 0.062745101749897003173828125);
        uint _2084 = _1975;
        float _2083 = _88(_2084).z;
        uint _2089 = _2072;
        vec3 _2088 = _88(_2089).xyz;
        float _2102 = _2075 - (_2075 * abs((_1877.z * 2.0) - 1.0));
        _1971 *= _10(_2102);
        float _2106 = _1971;
        if ((_1975 & 1u) != 0u)
        {
            vec3 _2113 = _2088;
            _2088 = vec3(0.0);
            uvec2 _2116 = _1702._m3;
            vec4 _2115 = _101(_2116);
            vec2 _2120 = _1950 * _2115.xy;
            vec2 _2125 = _1960 * _2115.xy;
            vec2 _2139 = (_1877.xy * _2115.xy) + _2115.zw;
            vec2 _2140 = _2120;
            vec2 _2142 = _2125;
            vec4 _2130 = _116(_1999, _2139, _2140, _2142);
            vec4 _2145 = _2130;
            _2130 = _70(_2145);
            _2088 = _2130.xyz;
            float _2157 = (_2130.w - _1888) / (1.0 - _1888);
            _2106 = _10(_2157);
            _2088 *= _2113;
        }
        vec3 _2162 = normalize(vec3(_693._m17[0].z, _693._m17[1].z, _693._m17[2].z));
        float _2171 = dot(_2162, normalize(_1864.xyz));
        float _2177 = _2171;
        vec2 _2182 = _1972.xy * _81(_2177);
        _1972 = vec3(_2182.x, _2182.y, _1972.z);
        if ((_1922 & 16384u) != 0u)
        {
            float _2195 = abs(_2171);
            _2186 = _10(_2195);
        }
        else
        {
            float _2198 = _2171;
            _2186 = _10(_2198);
        }
        float _2185 = _2186;
        float _2202 = ((_2185 * _2106) * _1978.w) * _2083;
        _693._m10 += (_1978.xyz * (_2202 * 64.0));
        uint _2221 = _1702._m10;
        uint _2225 = _2221;
        vec4 _2224 = _88(_2225);
        if ((_1975 & 2u) != 0u)
        {
            uvec2 _2234 = _1702._m4;
            vec4 _2233 = _101(_2234);
            vec2 _2238 = _1950 * _2233.xy;
            vec2 _2243 = _1960 * _2233.xy;
            vec2 _2256 = (_1877.xy * _2233.xy) + _2233.zw;
            vec2 _2257 = _2238;
            vec2 _2259 = _2243;
            _2224 = _116(_1999, _2256, _2257, _2259);
            _2224 *= _2224;
        }
        if ((_1975 & 32u) != 0u)
        {
            uint _2272 = _1975;
            float _2271 = _88(_2272).x;
            uint _2277 = _1975;
            float _2276 = _91(_2277).y;
            float _2283 = _2271;
            float _2281 = mix(_2276, 0.0, _10(_2283));
            float _2292 = _1970 - (_2281 / 255.0);
            float _2287 = float(_10(_2292) > 0.0);
            _1971 *= _2287;
        }
        float _2299 = _1971 * _2185;
        uint _2303 = _1702._m6;
        uint _2307 = _2303;
        vec4 _2312 = _88(_2307) * _2299;
        vec4 _2306 = _22(_2312);
        _693._m11 = max(_693._m11, _2306.x);
        _693._m0 = mix(_693._m0, _2088, _2306.xxx);
        _693._m2 = mix(_693._m2, _2224.xyz, _2306.yyy);
        vec3 _2335 = _2162;
        vec3 _2345 = _1861.xyz + (_2335 * dot(_1861.xyz, _2335));
        _1861 = vec4(_2345.x, _2345.y, _2345.z, _1861.w);
        vec3 _2356 = _1867.xyz + (_2335 * dot(_1867.xyz, _2335));
        _1867 = vec4(_2356.x, _2356.y, _2356.z, _1867.w);
        _1972 = ((normalize(_1861.xyz) * _1972.x) + (normalize(_1867.xyz) * _1972.y)) + (_2335 * _1972.z);
        if ((_1922 & 256u) != 0u)
        {
            vec3 _2383 = mix(_2162, _1972, _2306.www);
            float _2389 = dot(_2383, _2162);
            _1972 = (_693._m6 * _2389) + ((_2383 - (_2162 * _2389)) * dot(_693._m6, _2162));
        }
        else
        {
            if ((_1922 & 64u) != 0u)
            {
                _1972 = mix(mix(_693._m6, _2162, vec3(_2299)), _1972, _2306.www);
            }
            else
            {
                _1972 = mix(_693._m6, _1972, _2306.www);
            }
        }
        _693._m6 = normalize(_1972);
        _693._m3 = mix(_693._m3, _2224.w, _2306.z);
    }
    vec3 _2443 = vec3(0.0);
    _2443 = _693._m9 * _725._m10.x;
    float _2449;
    if (dot(_693._m10, vec3(1.0)) > 0.0)
    {
        _2449 = -_693._m3;
    }
    else
    {
        _2449 = _693._m3;
    }
    _693._m3 = _2449;
    _693._m18 = _2443;
    _693._m19 = _2443;
    uint _2469 = _1588;
    _2498 _2500;
    vec3 _2794;
    float _2885;
    float _2896;
    _3273 _3275;
    uint _3393;
    _3273 _3420;
    while (_2469 < _1589)
    {
        uint _2479 = _1677._m0[_2469];
        uint _2483 = _2479 & 4095u;
        uint _2486 = _2483;
        if (_2486 >= _2483)
        {
            _2469++;
        }
        int _2495 = 4;
        int _2496 = 4;
        int _2497 = 3;
        _2500._m0 = _2504._m0[(uint(_2495) * _2486) + 0u].xyz;
        float _2519 = _2504._m0[(uint(_2495) * _2486) + 0u].w;
        _2500._m1 = _39(_2519);
        _2500._m2 = _2504._m0[(uint(_2495) * _2486) + 1u];
        _2500._m3 = _2504._m0[(uint(_2495) * _2486) + 2u];
        _2500._m4 = _2543._m0[(uint(_2496) * _2486) + 0u];
        _2500._m5 = _2543._m0[(uint(_2496) * _2486) + 1u];
        _2500._m6 = _2543._m0[(uint(_2496) * _2486) + 2u];
        float _2573 = _2504._m0[(uint(_2495) * _2486) + 3u].x;
        _2500._m7.x = _39(_2573);
        float _2583 = _2504._m0[(uint(_2495) * _2486) + 3u].y;
        _2500._m7.y = _39(_2583);
        float _2593 = _2504._m0[(uint(_2495) * _2486) + 3u].z;
        _2500._m7.z = _39(_2593);
        float _2603 = _2504._m0[(uint(_2495) * _2486) + 3u].w;
        _2500._m7.w = _39(_2603);
        _2500._m8 = _2612._m0[(uint(_2497) * _2486) + 0u];
        _2500._m9 = _2612._m0[(uint(_2497) * _2486) + 1u];
        _2500._m10 = _2612._m0[(uint(_2497) * _2486) + 2u];
        float _2642 = _2543._m0[(uint(_2496) * _2486) + 3u].x;
        _2500._m11 = _39(_2642);
        float _2652 = _2543._m0[(uint(_2496) * _2486) + 3u].y;
        _2500._m12 = _39(_2652);
        _2500._m13 = _2543._m0[(uint(_2496) * _2486) + 3u].z;
        float _2670 = _2543._m0[(uint(_2496) * _2486) + 3u].w;
        _2500._m14 = _39(_2670);
        float _2675 = 0.0039215688593685626983642578125;
        vec4 _2676 = vec4(_693._m14, 1.0);
        float _2683 = 1.0 / dot(_2676, _2500._m6);
        vec3 _2689 = vec3(dot(_2676, _2500._m4) * _2683, dot(_2676, _2500._m5) * _2683, dot(_2676, _2500._m3));
        uint _2707 = _2500._m1;
        uint _2710 = _1500;
        _2710 |= 64u;
        float _2714 = _2689.x;
        float _2717 = _2689.y;
        float _2720 = _2689.z;
        bool _2725 = _55(_2714, _2717, _2720) <= _2675;
        bool _2742;
        if (!_2725)
        {
            float _2729 = _2689.x;
            float _2732 = _2689.y;
            float _2735 = _2689.z;
            _2742 = _50(_2729, _2732, _2735) >= (1.0 - _2675);
        }
        else
        {
            _2742 = _2725;
        }
        bool _2750;
        if (!_2742)
        {
            _2750 = (_2707 & _2710) != 0u;
        }
        else
        {
            _2750 = _2742;
        }
        if (_2750)
        {
            continue;
        }
        if ((_2707 & 3u) == 2u)
        {
            vec2 _2769 = fract((_2689.xy * _725._m11.xy) + _725._m11.zw);
            _2689 = vec3(_2769.x, _2769.y, _2689.z);
        }
        vec3 _2772 = _2500._m0;
        float _2775 = 1.0;
        float _2776 = 1.0;
        vec3 _2777 = vec3(0.0, 0.0, 1.0);
        vec3 _2778 = vec3(0.0, 0.0, 1.0);
        uint _2779 = _2500._m1;
        vec3 _2782 = (_2689 * 2.0) - vec3(1.0);
        vec2 _2787 = _2689.xy;
        vec3 _2790 = _2500._m10.xyz;
        if ((_2779 & 3u) == 2u)
        {
            _2794 = _2790;
        }
        else
        {
            _2794 = normalize(_2772 - _693._m14);
        }
        _2777 = _2794;
        _2777 = _2777;
        float _2814 = dot(_693._m6, _2777);
        float _2809 = _10(_2814);
        bool _2818 = _2809 <= _2675;
        bool _2825;
        if (_2818)
        {
            _2825 = (_2779 & 48u) == 0u;
        }
        else
        {
            _2825 = _2818;
        }
        if (_2825)
        {
            continue;
        }
        uvec2 _2830 = _2500._m7.zw;
        vec4 _2829 = _101(_2830);
        float _2835 = TEXTURE_LOD(_2836, vec4((_2787 * _2829.xy) + _2829.zw, 0.0, 0.0).xy, vec4((_2787 * _2829.xy) + _2829.zw, 0.0, 0.0).w).x;
        float _2862 = _2835 * _2835;
        uint _2866 = _2779 & 3u;
        bool _2871 = _2866 == 1u;
        bool _2883;
        if (!_2871)
        {
            bool _2876 = _2866 == 0u;
            bool _2882;
            if (_2876)
            {
                _2882 = _2500._m8.z != 0.0;
            }
            else
            {
                _2882 = _2876;
            }
            _2883 = _2882;
        }
        else
        {
            _2883 = _2871;
        }
        bool _2869 = _2883;
        if (_2869)
        {
            float _2889 = _2500._m8.w;
            _2885 = _10(_2889);
        }
        else
        {
            _2885 = 0.5;
        }
        float _2884 = _2885;
        bool _2898 = _2866 == 0u;
        bool _2904;
        if (_2898)
        {
            _2904 = _2500._m8.z != 0.0;
        }
        else
        {
            _2904 = _2898;
        }
        if (_2904)
        {
            float _2912 = sqrt(dot(_2782, _2782));
            _2896 = min(0.9921875, _10(_2912));
        }
        else
        {
            _2896 = _2689.z;
        }
        float _2895 = _2896;
        uvec2 _2920 = _2500._m7.xy;
        vec4 _2919 = _101(_2920);
        vec2 _2925 = vec2(_2895, _2884);
        float _2929 = TEXTURE_LOD(_2836, vec4((_2925 * _2919.xy) + _2919.zw, 0.0, 0.0).xy, vec4((_2925 * _2919.xy) + _2919.zw, 0.0, 0.0).w).x;
        _2929 *= _2929;
        _2775 = _2929 * _2862;
        if ((_2779 & 48u) != 0u)
        {
            vec4 _2966 = _2500._m10;
            vec4 _2969 = _2500._m8;
            vec4 _2972 = _2500._m9;
            float _2975 = dot(_693._m14, _2966.xyz) + _2966.w;
            if (_2975 < 0.0)
            {
                continue;
            }
            float _2989 = length(_2966.xyz);
            float _2996 = _2975 * 50.0;
            float _2993 = _10(_2996);
            _2775 *= (_2993 * _2993);
            _2975 /= _2989;
            _2966 /= vec4(_2989);
            vec3 _3010 = reflect(-_693._m13, _693._m6);
            if (dot(_3010, _2966.xyz) > 0.0)
            {
                _3010 = reflect(_3010, _2966.xyz);
            }
            float _3028 = dot(_3010, _2966.xyz);
            float _3033 = _2975 / _3028;
            vec3 _3037 = _693._m14 - (_3010 * _3033);
            vec3 _3044 = _3037 - _2772;
            float _3048 = dot(_3044, _2969.xyz) / _2969.w;
            float _3056 = dot(_3044, _2972.xyz) / _2972.w;
            if ((_2779 & 48u) == 32u)
            {
                vec2 _3069 = vec2(_3048, _3056);
                float _3073 = 1.0 / max(1.0, length(vec2(_3048, _3056)));
                _3048 *= (_3073 * _2969.w);
                _3056 *= (_3073 * _2972.w);
            }
            else
            {
                float _3095 = abs(_3048);
                float _3097 = _3048;
                _3048 = (_10(_3095) * _81(_3097)) * _2969.w;
                float _3106 = abs(_3056);
                float _3108 = _3056;
                _3056 = (_10(_3106) * _81(_3108)) * _2972.w;
            }
            vec3 _3115 = (_2969.xyz * _3048) + (_2972.xyz * _3056);
            _2772 += _3115;
            _2777 = normalize(_2772 - _693._m14);
            _2777 = _2777;
        }
        else
        {
            uint _3135 = (_2500._m14 >> uint(16)) & 255u;
            if (_3135 == 0u)
            {
                vec4 _3144 = _2500._m9;
                if (dot(_3144.xyz, _693._m14) < (_3144.w - _2675))
                {
                    continue;
                }
            }
            else
            {
                if (_3135 == 1u)
                {
                    vec3 _3165 = _2500._m9.xyz;
                    float _3170 = _2500._m9.w;
                    uint _3174 = _39(_3170);
                    vec3 _3169 = (((_95(_3174) * 2.0) - vec3(1.0)) * _3165) + _2772;
                    vec3 _3183 = abs((_693._m14 - _3169) / _3165);
                    float _3191 = _3183.x;
                    float _3194 = _3183.y;
                    float _3197 = _3183.z;
                    if (_50(_3191, _3194, _3197) > 1.0)
                    {
                        continue;
                    }
                }
            }
        }
        if (_2775 <= (_2675 / 256.0))
        {
            continue;
        }
        float _3213 = 1.0;
        if ((_2707 & 4u) != 0u)
        {
            float _3220 = float(_2500._m14 & 255u) / 255.0;
            float _3226 = 0.00999999977648258209228515625;
            vec3 _3228 = _693._m14 + (_693._m6 * _3226);
            uint _3236 = 0u;
            if ((_2707 & 3u) == 0u)
            {
                vec3 _3242 = _3228 - _2500._m2.xyz;
                float _3248 = _3242.x;
                float _3251 = _3242.y;
                float _3254 = _3242.z;
                _3236 = _61(_3248, _3251, _3254);
            }
            else
            {
                if ((_2707 & 3u) == 2u)
                {
                    float _3264 = 0.0;
                    for (; _3236 < 3u; _3236++)
                    {
                        int _3272 = 5;
                        _3275._m0 = _3279._m0[(uint(_3272) * ((_2707 >> uint(22)) + _3236)) + 0u];
                        _3275._m1 = _3279._m0[(uint(_3272) * ((_2707 >> uint(22)) + _3236)) + 1u];
                        _3275._m2 = _3279._m0[(uint(_3272) * ((_2707 >> uint(22)) + _3236)) + 2u];
                        _3275._m3 = _3279._m0[(uint(_3272) * ((_2707 >> uint(22)) + _3236)) + 3u];
                        _3275._m4 = _3279._m0[(uint(_3272) * ((_2707 >> uint(22)) + _3236)) + 4u];
                        vec2 _3336 = vec2(dot(_3228, _3275._m0.xyz) + _3275._m0.w, dot(_3228, _3275._m1.xyz) + _3275._m1.w);
                        _3336 = abs((_3336 * 2.0) - vec2(1.0));
                        bool _3361 = _3336.x < 1.0;
                        bool _3367;
                        if (_3361)
                        {
                            _3367 = _3336.y < 1.0;
                        }
                        else
                        {
                            _3367 = _3361;
                        }
                        if (_3367)
                        {
                            _3264 = (1.0 - max(_3336.x, _3336.y)) * _725._m12.w;
                            break;
                        }
                    }
                    _3236 = min(2u, _3236);
                    uint _3384 = uint(_693._m16.x) ^ (uint(_693._m16.y) << uint(1));
                    if (_725._m13.w > 0.0)
                    {
                        _3393 = uint(_725._m14.x);
                    }
                    else
                    {
                        _3393 = 0u;
                    }
                    _3384 ^= _3393;
                    _3236 += uint(int(((float(_3384 & 3u) * 0.25) + 0.125) > _3264));
                }
            }
            int _3419 = 5;
            _3420._m0 = _3279._m0[(uint(_3419) * ((_2707 >> uint(22)) + _3236)) + 0u];
            _3420._m1 = _3279._m0[(uint(_3419) * ((_2707 >> uint(22)) + _3236)) + 1u];
            _3420._m2 = _3279._m0[(uint(_3419) * ((_2707 >> uint(22)) + _3236)) + 2u];
            _3420._m3 = _3279._m0[(uint(_3419) * ((_2707 >> uint(22)) + _3236)) + 3u];
            _3420._m4 = _3279._m0[(uint(_3419) * ((_2707 >> uint(22)) + _3236)) + 4u];
            vec4 _3476 = vec4((_3228.x * _3420._m0.x) + ((_3228.y * _3420._m0.y) + ((_3228.z * _3420._m0.z) + _3420._m0.w)), (_3228.x * _3420._m1.x) + ((_3228.y * _3420._m1.y) + ((_3228.z * _3420._m1.z) + _3420._m1.w)), (_3228.x * _3420._m2.x) + ((_3228.y * _3420._m2.y) + ((_3228.z * _3420._m2.z) + _3420._m2.w)), (_3228.x * _3420._m3.x) + ((_3228.y * _3420._m3.y) + ((_3228.z * _3420._m3.z) + _3420._m3.w)));
            vec3 _3563 = _3476.xyz / vec3(_3476.w);
            _3476 = vec4(_3563.x, _3563.y, _3563.z, _3476.w);
            bool _3571 = min(_3476.x, _3476.y) > 0.0;
            bool _3580;
            if (_3571)
            {
                _3580 = max(_3476.x, _3476.y) < 1.0;
            }
            else
            {
                _3580 = _3571;
            }
            if (_3580)
            {
                vec2 _3592 = (_3476.xy * _3420._m4.xy) + _3420._m4.zw;
                _3476 = vec4(_3592.x, _3592.y, _3476.z, _3476.w);
                if (false)
                {
                    _3213 = textureLod(_3600, vec3(_3476.xyz.xy, _3476.xyz.z), 0.0);
                }
                else
                {
                    vec2 _3607 = (_3476.xy * _725._m15.xy) + vec2(0.5);
                    vec2 _3616 = floor(_3607);
                    vec2 _3619 = _3607 - _3616;
                    _3616 -= vec2(0.5);
                    vec2 _3626 = vec2(4.0) - (_3619 * 3.0);
                    vec2 _3632 = vec2(7.0);
                    vec2 _3635 = vec2(1.0) + (_3619 * 3.0);
                    vec2 _3640 = (_3616 + (((vec2(3.0) - (_3619 * 2.0)) / _3626) - vec2(2.0))) * _725._m15.zw;
                    vec2 _3655 = (_3616 + ((vec2(3.0) + _3619) / _3632)) * _725._m15.zw;
                    vec2 _3667 = (_3616 + ((_3619 / _3635) + vec2(2.0))) * _725._m15.zw;
                    vec3 _3691 = vec3(_3640.x, _3640.y, _3476.z);
                    _3213 = (_3626.x * _3626.y) * textureLod(_3600, vec3(_3691.xy, _3691.z), 0.0);
                    vec3 _3707 = vec3(_3655.x, _3640.y, _3476.z);
                    _3213 += ((_3632.x * _3626.y) * textureLod(_3600, vec3(_3707.xy, _3707.z), 0.0));
                    vec3 _3725 = vec3(_3667.x, _3640.y, _3476.z);
                    _3213 += ((_3635.x * _3626.y) * textureLod(_3600, vec3(_3725.xy, _3725.z), 0.0));
                    vec3 _3743 = vec3(_3640.x, _3655.y, _3476.z);
                    _3213 += ((_3626.x * _3632.y) * textureLod(_3600, vec3(_3743.xy, _3743.z), 0.0));
                    vec3 _3761 = vec3(_3655.x, _3655.y, _3476.z);
                    _3213 += ((_3632.x * _3632.y) * textureLod(_3600, vec3(_3761.xy, _3761.z), 0.0));
                    vec3 _3779 = vec3(_3667.x, _3655.y, _3476.z);
                    _3213 += ((_3635.x * _3632.y) * textureLod(_3600, vec3(_3779.xy, _3779.z), 0.0));
                    vec3 _3797 = vec3(_3640.x, _3667.y, _3476.z);
                    _3213 += ((_3626.x * _3635.y) * textureLod(_3600, vec3(_3797.xy, _3797.z), 0.0));
                    vec3 _3815 = vec3(_3655.x, _3667.y, _3476.z);
                    _3213 += ((_3632.x * _3635.y) * textureLod(_3600, vec3(_3815.xy, _3815.z), 0.0));
                    vec3 _3833 = vec3(_3667.x, _3667.y, _3476.z);
                    _3213 += ((_3635.x * _3635.y) * textureLod(_3600, vec3(_3833.xy, _3833.z), 0.0));
                    _3213 *= 0.0069444444961845874786376953125;
                }
            }
            else
            {
                _3213 = float((_2707 & 3u) == 2u);
            }
            float _3847 = float((_2707 >> uint(16)) & 63u) / 63.0;
            float _3861 = ((_3213 * _3847) + 1.0) - _3847;
            _3213 = _10(_3861);
        }
        uint _3864 = _2500._m12;
        vec3 _3863 = (_119(_3864) * _3213) * _2775;
        _2776 *= _2500._m13;
        vec3 _3876 = _3863;
        vec3 _3878 = _2777;
        float _3885 = dot(_693._m6, _3878);
        float _3880 = _10(_3885);
        vec3 _3891 = _693._m6;
        vec3 _3894 = _693._m13;
        vec3 _3897 = _2777;
        vec3 _3899 = _693._m2;
        float _3902 = abs(_693._m3);
        vec3 _3887 = _132(_3891, _3894, _3897, _3899, _3902);
        _693._m20 += (((_3887 * _2776) * _3876) * _3880);
        vec3 _3916 = mix(_3876, vec3(0.0), bvec3((_2707 & 256u) > 0u));
        _693._m19 += (_3916 * _3880);
    }
    _693._m19 = _693._m19;
    _693._m20 += _693._m10;
    float _3940 = 0.064999997615814208984375;
    float _3942 = 1.0 + _3940;
    bool _3945 = false;
    uint _3947;
    if (_725._m16.w > 0.00999999977648258209228515625)
    {
        _3947 = uint(_725._m16.x);
    }
    else
    {
        _3947 = 0u;
    }
    uint _3946 = _3947;
    _3968 _3970;
    for (uint _3958 = 0u; _3958 < _3946; _3958++)
    {
        int _3967 = 4;
        _3970._m0 = _3974._m0[(uint(_3967) * _3958) + 0u];
        _3970._m1 = _3974._m0[(uint(_3967) * _3958) + 1u];
        _3970._m2 = _3974._m0[(uint(_3967) * _3958) + 2u];
        float _4004 = _3974._m0[(uint(_3967) * _3958) + 3u].x;
        _3970._m3 = _39(_4004);
        float _4014 = _3974._m0[(uint(_3967) * _3958) + 3u].y;
        _3970._m4 = _39(_4014);
        float _4024 = _3974._m0[(uint(_3967) * _3958) + 3u].z;
        _3970._m5 = _39(_4024);
        vec4 _4029 = vec4(_693._m14, 1.0);
        vec3 _4036 = vec3(dot(_4029, _3970._m1), dot(_4029, _3970._m2), dot(_4029, _3970._m0));
        float _4050 = _4036.x;
        float _4053 = _4036.y;
        float _4056 = _4036.z;
        bool _4060 = _55(_4050, _4053, _4056) >= 0.0;
        bool _4069;
        if (_4060)
        {
            _4069 = max(_4036.x, _4036.y) < 1.0;
        }
        else
        {
            _4069 = _4060;
        }
        bool _4076;
        if (_4069)
        {
            _4076 = _4036.z < _3942;
        }
        else
        {
            _4076 = _4069;
        }
        if (_4076)
        {
            float _4079 = _4036.z;
            vec4 _4082 = vec4(_693._m14, 1.0);
            vec2 _4089 = vec2(0.0);
            _4089 = (((_4082.xy - _725._m17.zw) / vec2(16.0)) * 0.5) + vec2(0.5);
            float _4102 = 0.000244140625;
            float _4108 = abs(_693._m6.z) * 2.0;
            _4102 *= _10(_4108);
            vec3 _4112 = vec3(TEXTURE_LOD(_4113, vec4(_4089 + vec2(_4102), 0.0, 0.0).xy, vec4(_4089 + vec2(_4102), 0.0, 0.0).w).x, TEXTURE_LOD(_4113, vec4(_4089, 0.0, 0.0).xy, vec4(_4089, 0.0, 0.0).w).x, TEXTURE_LOD(_4113, vec4(_4089 - vec2(_4102), 0.0, 0.0).xy, vec4(_4089 - vec2(_4102), 0.0, 0.0).w).x);
            float _4176 = 2.0 - (2.0 * (length(_4082.xy - _725._m17.zw) / 16.0));
            _4112 *= _10(_4176);
            float _4183 = 1.0 - _4079;
            float _4180 = smoothstep(0.0, 0.00999999977648258209228515625, _10(_4183));
            float _4195 = (_693._m6.z * 0.800000011920928955078125) + 0.20000000298023223876953125;
            vec3 _4186 = (_4112 * _4180) * _10(_4195);
            float _4204 = _3942 - _4079;
            float _4198 = (1.0 - _4180) * smoothstep(0.0, 0.00999999977648258209228515625, _10(_4204));
            float _4219 = ((-_693._m6.z) * 0.89999997615814208984375) + 0.100000001490116119384765625;
            vec3 _4208 = (_4112 * _4198) * _10(_4219);
            _4112 = _4186 + _4208;
            float _4230 = 1.02499997615814208984375 - _4079;
            float _4225 = smoothstep(0.0, 0.02999999932944774627685546875, _10(_4230));
            float _4233 = _725._m16.w;
            _693._m19 = mix(_693._m19, (_693._m19 * _4112) + (_693._m19 * mix(1.0, 0.5, _4225)), vec3(_4233));
            break;
        }
    }
    _693._m19 *= _693._m0;
    _693._m21 = _693._m19 + _693._m20;
    vec3 _4273 = _693._m19 + _693._m20;
    _4268 = vec4(_4273.x, _4273.y, _4273.z, _4268.w);
    vec3 _4277 = _693._m6;
    bool _4280 = false;
    vec2 _4281 = _162(_4277, _4280);
    _4276 = vec4(_4281.x, _4281.y, _4276.z, _4276.w);
    float _4285 = _693._m2.x;
    float _4289 = _693._m2.y;
    float _4293 = _693._m2.z;
    float _4297 = _693._m3;
    _4284 = vec4(_84(_4285), _84(_4289), _84(_4293), _165(_4297));
    vec3 _4307 = _4268.xyz + _984._m2.xyz;
    _4268 = vec4(_4307.x, _4307.y, _4307.z, _4268.w);
}


